Name: yale-tftpd
Version: 3.0
Release: 1
Summary: Trivial file transfer protocol (tftpd) server with access-lists.
Copyright: BSD
Group: Networking/Daemons
Provides: tftpd
Source0: ftp://ftp.cert.dfn.de/pub/tools/net/yale-tftpd/yale-tftpd-3.0.tar.gz
Patch0:  yale-tftpd-3.0-Makefiles.patch
Patch1:  yale-tftpd-3.0-tftpd.c.patch
Patch2:  yale-tftpd-3.0-tftpd.8.patch
Packager: Riku Meskanen <mesrik@cc.jyu.fi>
BuildRoot: /var/tmp/yale-tftpd

%changelog

* Sat Jun 13 1998 Riku Meskanen <mesrik@cc.jyu.fi>

- added sample config file
- initial build with select(), getwd() and man page patches

%description 
The trivial file transfer protocol (tftp) is normally used for
booting and storing configuration files for diskless workstations 
and arbitrary networking devices.

Standard tftpd provides very little security, and should not 
be enabled unless it is needed. In the case tftpd is needed the 
yale-tftpd server provides better control via /etc/tftpd.conf
configuration file access lists.

You can have only one tftpd server, either the standard (BSD) 
based tftpd or this yale-tftpd enabled at time. The tftpd service 
is disabled by default.

%prep
%setup -c -n yale-tftpd-3.0
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
make

%install
mkdir -p $RPM_BUILD_ROOT/etc $RPM_BUILD_ROOT/usr/sbin \
	 $RPM_BUILD_ROOT/usr/man/man8 $RPM_BUILD_ROOT/usr/doc/yale-tftpd-3.0

install -o root -g root -m 755 tftpd $RPM_BUILD_ROOT/usr/sbin/yale-tftpd
install -o root -g root -m 644 tftpd.8 $RPM_BUILD_ROOT/usr/man/man8/yale-tftpd.8
install -o root -g root -m 644 README ChangeLog $RPM_BUILD_ROOT/usr/doc/yale-tftpd-3.0

find $RPM_BUILD_ROOT -type d |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) %dir #g" > rpm-files

find $RPM_BUILD_ROOT -type f |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) #g" >> rpm-files

echo "Writing tftpd.conf"
cat <<CONFIG >$RPM_BUILD_ROOT/etc/tftpd.conf
#
# Sample /etc/tftpd.conf, see yale-tftpd(8) for details
#
# Note: you should propably keep this file root owned, 
#       also root/wheel group and chmod the directories
#	permissions 2711 or even 2700. The less you reveal
#	what you have under tftpd accessed directories the
#	harder you make it for possible misuse.
#
# To enable the service edit your /etc/inetd.conf as shown 
# below and send HUP to inetd.
# 
# tftp    dgram   udp     wait    root    /usr/sbin/yale-tftpd in.tftpd 
#

# Seach here for unqualified file names
defaultDirectory   /tftpboot/default

# Don't search anywhere else but here
rootDirectory         /tftpboot

# access list 1 is OK for everyone on 192.168.1 net
# except 192.168.1.15;  192.168.1.17 is allowed to
# write files.
accessList         1  permit     192.168.1.0      0.0.0.255
accessList         1  deny       192.168.1.15
accessList         1  readwrite  192.168.1.17

# access list 2 is OK for everyone on 192.168.1 net
accessList         2  permit     192.168.1.0      0x000000ff

# access list 3 is readonly for everyone in the world
accessList         3  readonly   0.0.0.0          255.255.255.255

# access list 4 is just like 1, except allow write access to 21 subnet
accessList         4  +1
accessList         4  readwrite  192.168.2.0     0.0.0.255

# access to 'bootfile' controlled by access list 1
restrict           bootfile      1
defaultAccessList  3

# eof   
CONFIG
chmod 600 $RPM_BUILD_ROOT/etc/tftpd.conf
echo "%config /etc/tftpd.conf" >>rpm-files

%clean
rm -rf $RPM_BUILD_ROOT

%files -f rpm-files
